#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <at200.h>

int locate_at200(void)
{
int i,j,k;

  for( j=0,i=0x200 ; i < 0x400 ; i+=16 ) {
    inp(i);       /* On reset, the state machine requires one extra read */
    j = inp(i);
    if( j == 0x5A || j == 0xA5 ) {
      printf("Checking %Xh:\t%02Xh\n",i,j = inp(i));
      for( k=1 ; k<16 && (j == 0x5A || j == 0xA5) ; k++ )
        printf("\t %X:\t%02Xh\n",i+k,j = inp(i + k));
      if( j == 0x5A || j == 0xA5 )
        break;
    }
  }
  return( i );
}

void fix_address(void)
{
int i,j;

  printf("An AT200 has been located at address %Xh.\n",at200_base);
  outp((unsigned)at200_base + CONTROL,0x10);/* Enable Non-volatile Shift Register */
  i = (at200_base >> 4) & 31; /* Calculate Register Contents */
  for( j=0 ; j<5 ; j++ )
    outp((unsigned)at200_base + SAFE_WRITE,(i>>j) & 1); /* Write Bits 0..4 */
  /* Bit 5=0 for Auto Address, 1 for Normal Operation */
  outp((unsigned)at200_base + SAFE_WRITE,1);            /* Write Bit 5 */
  outp((unsigned)at200_base + SAFE_WRITE,0);            /* Write Bit 6 */
  outp((unsigned)at200_base + SAFE_WRITE,0);            /* Write Bit 7 */
  outp((unsigned)at200_base + CONTROL,0); /* Disable Non-volatile Shift Register */
  printf("The AT200's address is fixed at %Xh.\n",at200_base);
}

void main(int argc,char *argv[])
{
  at200_base = locate_at200();                      /* Find the hardware */
  if( at200_base == 0x400 )
    printf("No AT200 was found in auto-address mode.\n");
  else
    fix_address();
}
