#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <at200.h>

static char fmt[] = "outp(%Xh,%Xh);\n";

void main(int argc,char *argv[])
{
unsigned i,j,k;

  if( argc<2 ) {
    printf("USAGE: setbd -a NVRAM ADDR\n"
           "    Where:\n"
                 "\t-a\tSelects Auto Address Mode\n"
                 "\tNVRAM\tis the value to load into Non-volatile RAM (5 bits)\n"
                 "\tADDR\tis the base address of the AT200 board\n");
    exit( 1 );
  }
  for( i=0,j=k=1 ; j<(unsigned) argc ; j++ ) {
    if( argv[j][0] == '-' && tolower(argv[j][1]) == 'a' )
      k = 0;
    else if( i )
      at200_base = atoi(argv[j]);
    else
      i = atoi(argv[j]);
  }
  outp((unsigned) at200_base + CONTROL,0x10);/* Enable Write to Non-volatile RAM */
  printf("outp(%Xh,%Xh);\n",at200_base + CONTROL,0x10);
  for( j=0 ; j<5 ; j++ ) {
    outp((unsigned)at200_base + SAFE_WRITE,(int)(i>>j) & 1);/* Write Bits 0..4 */
    printf(fmt,at200_base + SAFE_WRITE,(i>>j) & 1);
  }
  /* Bit 5=0 for Auto Address, 1 for Normal Operation */
  outp((unsigned)at200_base + SAFE_WRITE,(int)k);   /* Write Bit 5 */
  printf(fmt,at200_base + SAFE_WRITE,k);
  outp((unsigned)at200_base + SAFE_WRITE,0);        /* Write Bit 6 */
  printf(fmt,at200_base + SAFE_WRITE,0);
  outp((unsigned)at200_base + SAFE_WRITE,0);        /* Write Bit 7 */
  printf(fmt,at200_base + SAFE_WRITE,0);
  outp((unsigned)at200_base + CONTROL,0); /* Disable Write to Non-volatile RAM */
  printf(fmt,at200_base + CONTROL,0);
}
