#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <at200.h>
#include <camera.h>

char *op[] = {
  "OP_TERMINATE\n",
  "OP_DO_LOOP (%u)\n",
  "OP_END_DO\n",
  "OP_CLEAR_UNTIL_TRIG\n",
  "OP_EXPOSE_SCALE (%u)\n",
  "OP_EXPOSE (%u)\n",
  "OP_OPEN_SHUTTER\n",
  "OP_CLOSE_SHUTTER\n",
  "OP_SELECT_I_S\n",
  "OP_SELECT_S\n",
  "OP_PARALLEL_DIS (%u)\n",
  "OP_PARALLEL_BIN (%u)\n",
  "OP_SERIAL_DIS (%u)\n",
  "OP_SET_SER_BIN (%u)\n",
  "OP_SERIAL_CONV (%u)\n",
  "OP_SET_GAIN (%u)\n",
  "OP_PREAMP_ON\n",
  "OP_PREAMP_OFF\n",
  "OP_WAIT_FOR_0\n",
  "OP_WAIT_FOR_1\n",
  "OP_EXPOSE_UNTIL_TRIG\n",
  "OP_DIAGNOSTIC_1 (%u)\n",
  "OP_EXPOSE_WHILE_TRIG\n",
  "OP_FLASH (%u)\n",
};

void main(int argc,char *argv[])
{
int data,cmd,x,indent = 10;

  if( argc>1 ) {
    if( argv[1][0] < '0' || argv[1][0] > '9' ) {
      printf("To select an AT200/M200 at an address other than 220h,"
                  " type UNLOAD #\n"
             "where # is the next to most signifficant HEX digit plus"
                  " the next higher bit.\n"
             "For example: UNLOAD 3 uses a controller at address 230h.\n"
             "             UNLOAD 4 uses a controller at address 240h.\n"
             "             UNLOAD 26 uses a controller at address 3A0h.\n");
      exit( 0 );
    }
    else
      at200_base = 0x200 + ((atoi(argv[1]) & 0x1F) << 4);
  }
  printf("Photometrics AT200/M200 Camera Operation Script Listing.\n\n");
  if( !(inp(at200_base + CONTROL) & DSP_RESET) ) {
    printf("DSP is in the reset state.\n");
    exit( 0 );
  }
  if( inp(at200_base + DSP_NULL) ) {
    printf("DSP is unresponsive.\n");
    exit( 0 );
  }
  dsp_command( UNLOAD_OPERATIONS );
  for( x=1 ; x && !(inp(at200_base + DSP_INTERRUPT_STATUS) &
                    DSP_RECEIVE_DATA_FULL) ; x++ )
    ;
  if( !x ) { /* Timeout! */
    printf("No DSP Program Data Available.\n");
    exit( 0 );
  }
  while( inp(at200_base + DSP_INTERRUPT_STATUS) & DSP_RECEIVE_DATA_FULL ) {
    data = inp(at200_base + DSP_XFER_HIGH) << 8;
    data |= inp(at200_base + DSP_XFER_MIDDLE);
    cmd = inp(at200_base + DSP_XFER_LOW);
    if( cmd == OP_END_DO )
      indent -= 2;
    for( x=0 ; x<indent ; x++ )
      printf(" ");
    if( cmd >= 0 && cmd <= OP_FLASH )
      printf(op[cmd],data);
    else
      printf("*** INVALID OPERATION 0x%02X (0x%04X) ***\n",cmd,data);
    if( cmd == OP_DO_LOOP )
      indent += 2;
  }
  exit( 0 );
}
